/*
 * JPA DAO Template
 *
 *
 * Takatuka - Template fuer JPA DAO (Extended = ExtendedPersistenceContext ConversationScope (Group = EntityExtendedDAO.class)
 *
 */

package de.ivu.elect.business.gebietsbaum.boundary;

import javax.inject.Inject;

import de.ivu.elect.business.gebietsbaum.entity.Gebietsgruppierung;
import de.ivu.elect.jee.entity.ExtendedDAO;

@javax.enterprise.context.RequestScoped
public class GebietsgruppierungExtendedDAO extends AbstractGebietsgruppierungDAO implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  @Inject
  transient ExtendedDAO extendedDAO;

  @Inject
  transient de.ivu.elect.presentation.system.ExtendedDAORequestCache cache;

  @Override
  protected javax.persistence.EntityManager getEntityManager() {
    return extendedDAO.getEntityManager();
  }

  @Override
  public void flush() {
    extendedDAO.flush();
  }

  public void flushNewTransaction() {
    extendedDAO.flushNewTransaction();
  }

/**
* Name: WahlAndGebietsgruppierungArtenNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT obj FROM Gebietsgruppierung obj WHERE obj.wahl = ?1 AND obj.gebietsgruppierungArt IN (?2)<br>
* SQL: <br>
*/
@Override
public java.util.List<Gebietsgruppierung> findByWahlAndGebietsgruppierungArten( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl,  @javax.annotation.Nonnull java.util.Collection<String> gebietsgruppierungArten) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Gebietsgruppierung.findByWahlAndGebietsgruppierungArten" ,  wahl ,  gebietsgruppierungArten  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlAndGebietsgruppierungArten(): Miss");
        }

        cache.put(key, super.findByWahlAndGebietsgruppierungArten( wahl ,  gebietsgruppierungArten  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlAndGebietsgruppierungArten(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Gebietsgruppierung>) cache.lookup(key));
    }

    return super.findByWahlAndGebietsgruppierungArten( wahl ,  gebietsgruppierungArten  );
}
/**
* Name: WahlNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT obj FROM Gebietsgruppierung obj WHERE obj.wahl = ?1<br>
* SQL: <br>
*/
@Override
public java.util.List<Gebietsgruppierung> findByWahl( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahl wahl) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Gebietsgruppierung.findByWahl" ,  wahl  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahl(): Miss");
        }

        cache.put(key, super.findByWahl( wahl  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahl(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Gebietsgruppierung>) cache.lookup(key));
    }

    return super.findByWahl( wahl  );
}
/**
* Name: WahlterminAndGebietsgruppierungArtenNoFlush<br>
* Beschreibung: <br>
* EJBQL: SELECT obj FROM Gebietsgruppierung obj WHERE obj.wahltermin = ?1 AND obj.gebietsgruppierungArt IN (?2)<br>
* SQL: <br>
*/
@Override
public java.util.List<Gebietsgruppierung> findByWahlterminAndGebietsgruppierungArten( @javax.annotation.Nonnull de.ivu.elect.business.wahl.entity.Wahltermin wahltermin,  @javax.annotation.Nonnull java.util.Collection<String> gebietsgruppierungArten) {

    if (de.ivu.elect.business.system.control.CacheQueries.CACHE_QUERIES) {
      de.ivu.elect.presentation.system.FinderKey key = new de.ivu.elect.presentation.system.FinderKey("Gebietsgruppierung.findByWahlterminAndGebietsgruppierungArten" ,  wahltermin ,  gebietsgruppierungArten  );

      if (!cache.contains(key)) {
        if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
          System.out.println("Query: " + getClass().getName() + ".findByWahlterminAndGebietsgruppierungArten(): Miss");
        }

        cache.put(key, super.findByWahlterminAndGebietsgruppierungArten( wahltermin ,  gebietsgruppierungArten  ));
      } else if (de.ivu.elect.business.system.control.LogQueries.LOG_QUERIES) {
        System.out.println("Query: " + getClass().getName() + ".findByWahlterminAndGebietsgruppierungArten(): Hit");
      }

      return new java.util.ArrayList<>((java.util.List<Gebietsgruppierung>) cache.lookup(key));
    }

    return super.findByWahlterminAndGebietsgruppierungArten( wahltermin ,  gebietsgruppierungArten  );
}

  @Override
  public void clear() {
    cache.clear();

    super.clear();
  }
}
